'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var defaultConfig = {
  origin: '*',
  methods: 'GET, PUT, POST, DELETE, OPTIONS',
  headers: 'Origin, X-Requested-With, Content-Type, Accept, Authorization'
};

var accessControl = exports.accessControl = function accessControl() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (app) {
    var ops = _extends({}, defaultConfig, config);

    app.use(function (req, res, next) {
      res.header('Access-Control-Allow-Origin', ops.origin);
      res.header('Access-Control-Allow-Methods', ops.methods);
      res.header('Access-Control-Allow-Headers', ops.headers);
      next();
    });
  };
};