'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var noCache = exports.noCache = function noCache() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (app) {
    app.use(function (req, res, next) {
      var api = config.api ? config.api : '/api/';

      if (req.url.startsWith(api)) {
        res.setHeader('Cache-Control', 'no-cache, no-store, must-revalidate');
        res.setHeader('Pragma', 'no-cache');
        res.setHeader('Expires', 0);
      }

      next();
    });
  };
};