'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _configurations = require('./configurations');

Object.keys(_configurations).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _configurations[key];
    }
  });
});

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _configure = require('./configure');

var _configure2 = _interopRequireDefault(_configure);

var _routes = require('./routes');

var _routes2 = _interopRequireDefault(_routes);

var _postStart = require('./postStart');

var _postStart2 = _interopRequireDefault(_postStart);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// compile
var compileConfiguration = function compileConfiguration() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var bitsConfig = arguments[1];
  return {
    port: options.port || 3000,
    configurations: options.configurations || [],
    postStart: options.postStart || [],

    schema: bitsConfig.schema,
    routes: bitsConfig.routes,

    hooks: options.hooks || [],
    database: bitsConfig.database
  };
};

// create bit
var initializeServer = function initializeServer(options) {
  return function (bitsConfig) {
    var config = compileConfiguration(options, bitsConfig);

    // create and configure the app
    var app = (0, _express2.default)();

    (0, _configure2.default)(app, config);
    (0, _routes2.default)(app, config);

    // start the server
    var server = app.listen(process.env.PORT || config.port);

    (0, _postStart2.default)(app, server, config);
  };
};

// export server

exports.default = function (options) {
  return {
    initializeServer: initializeServer(options)
  };
};

// export oob configurations